<template>
  <div>
    <mt-page-title>
      <h1 class="has-text-weight-bold is-size-3">Liste des postes au RO</h1>
    </mt-page-title>
    <div class="columns is-vcentered mt-marginless-bottom">
      <h3 class="has-text-weight-bold has-text-grey is-size-5 column">Nombre total de postes au RO : {{ total }}</h3>
      <div class="column is-narrow">
        <nuxt-link :to="{ name: 'profil-dashboard-postesro-creer', params: { profil: 'admin' } }">
          <b-button icon-left="plus" type="is-primary" class="mt-button is-size-8 ">Créer un Poste au RO</b-button>
        </nuxt-link>
      </div>
    </div>

    <mt-list v-slot="{ item: posteRo }" :list="postesRo">
      <mt-list-item>
        <div class="columns is-vcentered">
          <nuxt-link
            :to="{ name: 'profil-dashboard-postesro-id-editer', params: { profil: 'admin', id: posteRo.id } }"
            class="columns column"
          >
            <div class="column is-narrow">
              <mt-pastille>{{ posteRo.ordre }}</mt-pastille>
            </div>
            <div class="column">{{ posteRo.code }}</div>
            <div class="column">{{ posteRo.libelle }}</div>
          </nuxt-link>

          <div class="column is-narrow">
            <b-button type="is-danger" icon-left="delete" @click="confirmeSupprimer(posteRo)">Supprimer</b-button>
          </div>
        </div>
      </mt-list-item>
    </mt-list>
    <mt-modal-action type-delete :ouvert.sync="ouvertDelete" @action="supprimerPosteRo">
      Êtes-vous certain(e) de vouloir supprimer le poste au RO ?
    </mt-modal-action>
    <b-pagination
      :total="total"
      :current="pageCourante"
      :per-page="parPage"
      order="is-centered"
      aria-next-label="Postes au Ro suivant"
      aria-previous-label="Postes au Ro précedent"
      aria-page-label="Postes au RO"
      aria-current-label="Page courante"
      @change="getPostesRo"
    />
  </div>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';
import MtList from '~/components/base/list/index';
import MtListItem from '~/components/base/list/list-item';
import MtModalAction from '~/components/modal/mt-modal-action';
import MtPastille from '~/components/base/pastille/index';

export default {
  layout: 'dashboard',
  components: {
    MtPastille,
    MtPageTitle,
    MtList,
    MtListItem,
    MtModalAction,
  },
  async asyncData({ $api }) {
    const pageCourante = 1;
    const parPage = 30;
    const { content: postesRo, totalElements: total, numberOfElements: nombrePageCourante } = await $api.postesRo.all(
      pageCourante - 1,
      parPage,
    );
    return {
      postesRo,
      pageCourante,
      parPage,
      total,
      nombrePageCourante,
      ouvertDelete: false,
      posteRoASupprimer: null,
    };
  },
  methods: {
    async getPostesRo(page) {
      this.pageCourante = page;
      ({
        content: this.postesRo,
        totalElements: this.total,
        numberOfElements: this.nombrePageCourante,
      } = await this.$api.postesRo.all(this.pageCourante - 1, this.parPage));
    },
    confirmeSupprimer(posteRo) {
      this.ouvertDelete = true;
      this.posteRoASupprimer = posteRo;
    },
    async supprimerPosteRo() {
      try {
        await this.$api.postesRo.delete(this.posteRoASupprimer.id);
        this.posteRoASupprimer = null;
        let page = this.pageCourante;
        if (this.nombrePageCourante === 1 && this.pageCourante > 1) {
          page = this.pageCourante - 1;
        }
        this.getPostesRo(page);
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
  },
};
</script>

<style scoped lang="scss">
.columns.column {
  margin-bottom: 0;
}
</style>
